<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 499.1   Patch: 8                                                  |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Files
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function AdminManageFilesQueue
 * A function to manage the file queue
 * @author Philipp Louis Esselbach
 */
function AdminManageFilesQueue( $opts )
{
	global $database, $system, $security, $preferences, $html, $words_files;
	$options = explode( "-", $opts );
	$options[ 0 ] = ( isset( $options[ 0 ] ) ) ? $security -> checkvar( $options[ 0 ] ) : "" ;
	$options[ 1 ] = ( isset( $options[ 1 ] ) ) ? $security -> checknum( $options[ 1 ] ) : "" ;
	$options[ 2 ] = ( isset( $options[ 2 ] ) ) ? $security -> checkvar( $options[ 2 ] ) : "" ;
	
	if( $options[ 0 ] )
	{	
		if( ( $system -> adminhashget() != $options[ 2 ] ) and( $preferences[ 'website_subsessions_admin' ] ) )
		{
			$html -> login( $words_files[ 'ERROR' ], $words_files[ 'INVALID_SESSION' ], "index.php" );
			exit;
		}
	}

	if( $options[ 0 ] == "deletefile" )
	{
		$database -> dbquery( "DELETE FROM " . DB_PREFIX . "esselbach_ct_filesqueue WHERE filequeue_id = '" . $options[ 1 ] . "'" );
		$options[ 0 ] = "";
	}

	if( $options[ 0 ] == "editfile" )
	{
		include( "admineditqueuefile.php" );
		AdminEditQueueFile( $options[ 1 ], "" );
	}

	if( !$options[ 0 ] )
	{
		$security_hash = $system -> adminhashput();
		
		$input_search_name = ( isset( $_GET[ 'input_search_name' ] ) ) ? $security -> checkvar( $_GET[ 'input_search_name' ] ) : "" ;
		$input_search_content = ( isset( $_GET[ 'input_search_content' ] ) ) ? $security -> checkvar( $_GET[ 'input_search_content' ] ) : "" ;
		$input_search_author = ( isset( $_GET[ 'input_search_author' ] ) ) ? $security -> checkvar( $_GET[ 'input_search_author' ] ) : "" ;
		$input_search_category = ( isset( $_GET[ 'input_search_category' ] ) ) ? $security -> checkvar( $_GET[ 'input_search_category' ] ) : "" ;
		$input_search_status = ( isset( $_GET[ 'input_search_status' ] ) ) ? $security -> checknum( $_GET[ 'input_search_status' ] ) : "" ;
		$input_search_sort = ( isset( $_GET[ 'input_search_sort' ] ) ) ? $security -> checknum( $_GET[ 'input_search_sort' ] ) : "" ;
		$input_search_order = ( isset( $_GET[ 'input_search_order' ] ) ) ? $security -> checknum( $_GET[ 'input_search_order' ] ) : "" ;
		$input_search_page = ( isset( $_GET[ 'input_search_page' ] ) ) ? $security -> checknum( $_GET[ 'input_search_page' ] ) : "" ;
		
		if( !$input_search_status )
		{
			$input_search_status = 0;
		}
		
		$input_query = array();
		
		if( $input_search_name )
		{
			$input_query[ ] = "(filequeue_name LIKE '%" . $input_search_name . "%')";
		}
		
		if( $input_search_content )
		{
			$input_query[ ] = "(filequeue_smalldescription LIKE '%" . $input_search_content . "%' OR filequeue_longdescription LIKE '%" . $input_search_content . "%')";
		}
		
		if( $input_search_author )
		{
			$input_query[ ] = "(filequeue_author LIKE '%" . $input_search_author . "%')";
		}
		
		if( $input_search_category )
		{
			$input_query[ ] = "(filequeue_category = '" . $input_search_category . "')";
		}
		
		$input_query[ ] = "filequeue_status = '" . $input_search_status . "'";
		
		if( $input_query )
		{
			$input_full_query = "WHERE " . join( " AND ", $input_query );
		}
		else
		{
			$input_full_query = "";
		}
		
		if( $input_search_sort )
		{
			if( $input_search_sort == 1 )
			{
				$input_sort_query = "filequeue_name";
			}
			
			if( $input_search_sort == 2 )
			{
				$input_sort_query = "filequeue_smalldescription";
			}
			
			if( $input_search_sort == 3 )
			{
				$input_sort_query = "filequeue_longdescription";
			}
			
			if( $input_search_sort == 4 )
			{
				$input_sort_query = "filequeue_category";
			}
			
			if( $input_search_sort == 5 )
			{
				$input_sort_query = "filequeue_website";
			}
			
			if( $input_search_sort == 6 )
			{
				$input_sort_query = "filequeue_author";
			}
			
			if( $input_search_sort == 7 )
			{
				$input_sort_query = "filequeue_company";
			}
		}
		else
		{
			$input_sort_query = "filequeue_id";
		}
		
		if( !$input_search_order )
		{
			$input_sort_query .= " DESC";
		}
		
		$html -> makeheader( $words_files[ 'FILES_QUEUE' ] );
		$html -> deleteinit( $words_files[ 'ARE_YOU_SURE' ] );
		$html -> checkinit();
		$html -> makesubheader();
		$html -> makegroupmenu( "files" );
		$html -> makeformheader( $words_files[ 'FILES_QUEUE' ], "file", "filesearch", "get" );
		echo $words_files[ 'SEARCH_FORM_FILES' ] . "<br />";
		echo "<strong>" . $words_files[ 'FILE_NAME' ] . ":</strong> <input name=\"input_search_name\" size=\"32\" value=\"" . stripslashes( $input_search_name ) . "\" /> ";
		echo "<strong>" . $words_files[ 'CONTENT' ] . ":</strong> <input name=\"input_search_content\" size=\"32\" value=\"" . stripslashes( $input_search_content ) . "\" /> ";
		echo "<input type=\"hidden\" name=\"action\" value=\"filesqueue\" /><input type=\"submit\" value=\"" . $words_files[ 'GO' ] . "\" /><br />";
		echo "<strong>" . $words_files[ 'AUTHOR' ] . ":</strong> <input name=\"input_search_author\" size=\"12\" value=\"" . stripslashes( $input_search_author ) . "\" /> ";
		echo "<strong>" . $words_files[ 'CATEGORY' ] . ":</strong> <select size=\"1\" name=\"input_search_category\">";
		$category_name = array();
		$category_name[ 0 ] = $words_files[ 'NONE' ];
		echo "<option value=\"0\">" . $words_files[ 'NONE' ] . "</option>";
		$query = $database -> dbquery( "SELECT filecat_id, filecat_name FROM " . DB_PREFIX . "esselbach_ct_filescats" );
		
		if( $database -> dbrows( $query ) )
		{
			while( list( $filecat_id, $filecat_name ) = $database -> dbrow( $query ) )
			{
				$category_name[ $filecat_id ] = $filecat_name;
				
				if( $filecat_id == $input_search_category )
				{
					echo "<option selected=\"selected\" value=\"" . $filecat_id . "\">" . $filecat_name . "</option>";
				}
				else
				{
					echo "<option value=\"" . $filecat_id . "\">" . $filecat_name . "</option>";
				}
			}
		}
		
		echo "</select><br />";
		( !$input_search_status ) ? $status_new = "selected=\"selected\"" : $status_new = "" ;
		( $input_search_status == 1 ) ? $status_approved = "selected=\"selected\"" : $status_approved = "" ;
		( $input_search_status == 2 ) ? $status_rejected = "selected=\"selected\"" : $status_rejected = "" ;
		echo "<strong>" . $words_files[ 'STATUS' ] . ":</strong> <select size=\"1\" name=\"input_search_status\">";
		echo "<option " . $status_new . "value=\"0\">" . $words_files[ 'NEW' ] . "</option>";
		echo "<option " . $status_approved . "value=\"1\">" . $words_files[ 'APPROVED' ] . "</option>";
		echo "<option " . $status_rejected . "value=\"2\">" . $words_files[ 'REJECTED' ] . "</option>";
		echo "</select> ";
		( !$input_search_sort ) ? $sort_id = "selected=\"selected\" " : $sort_id = "" ;
		( $input_search_sort == 1 ) ? $sort_name = "selected=\"selected\" " : $sort_name = "" ;
		( $input_search_sort == 2 ) ? $sort_smalldescription = "selected=\"selected\" " : $sort_smalldescription = "" ;
		( $input_search_sort == 3 ) ? $sort_longdescription = "selected=\"selected\" " : $sort_longdescription = "" ;
		( $input_search_sort == 4 ) ? $sort_category = "selected=\"selected\" " : $sort_category = "" ;
		( $input_search_sort == 5 ) ? $sort_website = "selected=\"selected\" " : $sort_website = "" ;
		( $input_search_sort == 6 ) ? $sort_author = "selected=\"selected\" " : $sort_author = "" ;
		( $input_search_sort == 7 ) ? $sort_company = "selected=\"selected\" " : $sort_company = "" ;
		echo "<strong>" . $words_files[ 'SORT_BY' ] . ":</strong> <select size=\"1\" name=\"input_search_sort\">";
		echo "<option " . $sort_id . "value=\"0\">" . $words_files[ 'ID' ] . "</option>";
		echo "<option " . $sort_name . "value=\"1\">" . $words_files[ 'TITLE' ] . "</option>";
		echo "<option " . $sort_smalldescription . "value=\"2\">" . $words_files[ 'SMALL_DESCRIPTION' ] . "</option>";
		echo "<option " . $sort_longdescription . "value=\"3\">" . $words_files[ 'LONG_DESCRIPTION' ] . "</option>";
		echo "<option " . $sort_category . "value=\"4\">" . $words_files[ 'CATEGORY' ] . "</option>";
		echo "<option " . $sort_website . "value=\"5\">" . $words_files[ 'WEBSITE' ] . "</option>";
		echo "<option " . $sort_author . "value=\"6\">" . $words_files[ 'AUTHOR' ] . "</option>";
		echo "<option " . $sort_company . "value=\"7\">" . $words_files[ 'COMPANY' ] . "</option>";
		echo "</select> ";
		( !$input_search_order ) ? $sort_descending = "selected=\"selected\" " : $sort_descending = "" ;
		( $input_search_order == 1 ) ? $sort_ascending = "selected=\"selected\" " : $sort_ascending = "" ;
		echo "<select size=\"1\" name=\"input_search_order\">";
		echo "<option " . $sort_descending . "value=\"0\">" . $words_files[ 'DESCENDING' ] . "</option>";
		echo "<option " . $sort_ascending . "value=\"1\">" . $words_files[ 'ASCENDING' ] . "</option>";
		echo "</select> ";
		$query = $database -> dbquery( "SELECT COUNT(filequeue_id) FROM " . DB_PREFIX . "esselbach_ct_filesqueue " . $input_full_query . " ORDER BY " . $input_sort_query );
		list( $all_pages ) = $database -> dbrow( $query );
		
		if( !$input_search_status and $all_pages )
		{
			echo "<br /><br />" . $words_files[ 'THERE_ARE' ] . " " . $all_pages . " " . $words_files[ 'NEW_SUBMISSIONS_IN_QUERE' ] . " <a href=\"index.php?action=processfilesqueue\">" . $words_files[ 'CLICK_HERE' ] . "</a> " . $words_files[ 'TO_PROCESS_THEM_ALL' ];
		}
		
		if( $input_search_page )
		{
			$input_search_dbpage = $input_search_page - 1;
			$page = $input_search_dbpage * 50;
		}
		else
		{
			$page = 0;
		}
		
		$all_pages_rounded = ceil( $all_pages/50 );
		$query = $database -> dbquery( "SELECT filequeue_website, filequeue_name, filequeue_version, filequeue_id, filequeue_author FROM " . DB_PREFIX . "esselbach_ct_filesqueue " . $input_full_query . " ORDER BY " . $input_sort_query . " LIMIT " . $page . ",50" );
		$pages = $database -> dbrows( $query );
		
		if( $pages )
		{
			$html -> makeformsubfooter();
			
			if( ( $page < $all_pages ) and( $all_pages_rounded > 1 ) )
			{
				echo "<span class=\"pagelink\">" . $all_pages_rounded . " " . $words_files[ 'PAGES' ] . "</span> ";
				$html -> printpages( $all_pages_rounded, "index.php?action=filesqueue&amp;input_search_name=" . $input_search_name . "&amp;input_search_content=" . $input_search_content . "&amp;input_search_author=" . $input_search_author . "&amp;input_search_category=" . $input_search_category . "&amp;input_search_status=" . $input_search_status . "&amp;input_search_sort=" . $input_search_sort . "&amp;input_search_order=" . $input_search_order . "&amp;input_search_page", $input_search_page );
			}
			
			$html -> table5header( $words_files[ 'FILE_SITEID' ], $words_files[ 'NAME' ], $words_files[ 'VERSION' ], $words_files[ 'AUTHOR' ] );
			
			while( list( $filequeue_website, $filequeue_name, $filequeue_version, $filequeue_id, $filequeue_author ) = $database -> dbrow( $query ) )
			{
				$html -> table5middle( $filequeue_id . " / " . $filequeue_website, htmlspecialchars( $filequeue_name ), htmlspecialchars( $filequeue_version ), $filequeue_author, "filesqueue&amp;opts=editfile-" . $filequeue_id . "-" . $security_hash, "filesqueue&amp;opts=deletefile-" . $filequeue_id . "-" . $security_hash );
			}
			
			$html -> table5col( "<input type=\"hidden\" name=\"input_security_hash\" value=\"" . $security_hash . "\" /><input type=\"hidden\" name=\"aform\" value=\"filesqueueoptions\" /><select size=\"1\" name=\"input_option\"><optgroup label=\"" . $words_files[ 'FILES_QUEUE_OPTIONS' ] . "\"><option value=\"0\">" . $words_files[ 'DELETE_CHECKED' ] . "</option><option value=\"1\">" . $words_files[ 'REJECT_CHECKED' ] . "</option></optgroup></select><input type=\"submit\" value=\"" . $words_files[ 'GO' ] . "\" />" );
			$html -> maketablefooter();
			$html -> makeformsubfooter();
			
			if( ( $page < $all_pages ) and( $all_pages_rounded > 1 ) )
			{
				echo "<span class=\"pagelink\">" . $all_pages_rounded . " " . $words_files[ 'PAGES' ] . "</span> ";
				$html -> printpages( $all_pages_rounded, "index.php?action=filesqueue&amp;input_search_name=" . $input_search_name . "&amp;input_search_content=" . $input_search_content . "&amp;input_search_author=" . $input_search_author . "&amp;input_search_category=" . $input_search_category . "&amp;input_search_status=" . $input_search_status . "&amp;input_search_sort=" . $input_search_sort . "&amp;input_search_order=" . $input_search_order . "&amp;input_search_page", $input_search_page );
			}
		}
		else
		{
			echo "<br />" . $words_files[ 'NO_MATCHES' ] . "</div>";
		}
		
		echo "</div>";
	}
}
?>