<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 499.1   Patch: 7                                                  |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Files
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function FilesDownload
 * A function to start a file download
 * @author Philipp Louis Esselbach
 */
function FilesDownload()
{
	global $database, $templates, $system, $preferences, $security, $config;
	session_start();
	
	if( isset( $_SESSION[ 'filedownload_url' ] ) )
	{
		header( "location: " . base64_decode( $_SESSION[ 'filedownload_url' ] ) );
		exit;
	}
	else
	{
		$templates -> initgzip();
		$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','files_header','files_error_download','files_footer'", $preferences[ 'current_theme' ] );
		$insert = $system -> getinsert( $preferences, $main_templates );
		$insert[ 'page_name' ] = htmlspecialchars( $preferences[ 'website_name' ] );
		$insert[ 'page_description' ] = htmlspecialchars( $preferences[ 'website_description' ] );
		$insert[ 'page_keywords' ] = htmlspecialchars( $preferences[ 'website_keywords' ] );
		
		if( $preferences[ 'files_allow_rss' ] )
		{
			$insert[ 'page_rss' ] = $templates -> exectemplate( $main_templates[ 'files_rss_html' ], $main_templates[ 'files_rss_php' ], $insert );
		}
		
		$filelog_url = ( isset( $_SERVER[ 'HTTP_REFERER' ] ) ) ? $security -> checkvar( $_SERVER[ 'HTTP_REFERER' ] ) : "" ;
		
		if( $filelog_url )
		{
			$query = $database -> dbquery( "SELECT filelog_id FROM " . DB_PREFIX . "esselbach_ct_fileslogs WHERE filelog_url = '" . $filelog_url . "' AND filelog_website = '" . intval( $config[ 'WEBSITE' ] ) . "' LIMIT 1" );
			
			if( $database -> dbrows( $query ) )
			{
				$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_fileslogs SET filelog_count = filelog_count + 1, filelog_activity = now() WHERE filelog_url = '" . $filelog_url . "' AND filelog_website = '" . intval( $config[ 'WEBSITE' ] ) . "'" );
			}
			else
			{
				$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_fileslogs (filelog_id, filelog_website, filelog_url, filelog_count, filelog_activity) VALUES (NULL, '" . intval( $config[ 'WEBSITE' ] ) . "', '" . $filelog_url . "', '1', now())" );
			}
		}
		
		echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
		
		if( $preferences[ 'files_navigation' ] )
		{
			echo $templates -> exectemplate( $main_templates[ 'files_header_html' ], $main_templates[ 'files_header_php' ], $insert );
		}
		
		echo $templates -> exectemplate( $main_templates[ 'files_error_download_html' ], $main_templates[ 'files_error_download_php' ], $insert );
		
		if( $preferences[ 'files_navigation' ] )
		{
			echo $templates -> exectemplate( $main_templates[ 'files_footer_html' ], $main_templates[ 'files_footer_php' ], $insert );
		}
	}
}
?>