<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Professional/Business Edition 2008.0                    |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2008 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | This is a commercial version of Contentteller and not free software.     |
// | You may not redistribute this file or its derivatives without written    |
// | permission.                                                              |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+  
// | Build: 499.1   Patch: 8                                                  |  
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Files
 * @copyright (C) 2002-2008 Esselbach Internet Solutions
 */

/**
 * function FilesGet
 * A function to get a file
 * @author Philipp Louis Esselbach
 */
function FilesGet( $page )
{
	global $config, $database, $templates, $system, $security, $preferences, $user;
	$templates -> initgzip();
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','site_invalid_form','files_header','files_get_header','files_get','files_get_password','files_get_agreement','files_rating_1star','files_rating_2stars','files_rating_3stars','files_rating_4stars','files_rating_5stars','files_error_nofile','files_error_password','files_get_footer','files_footer','files_layout_get'", $preferences[ 'current_theme' ] );
	list( $page_query, $opt ) = $system -> getpages( $page, 0 );
	$insert = $system -> getinsert( $preferences, $main_templates );
	
	if( $user[ 'user_status' ] == 1 )
	{
		$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '3')";
	}
	elseif( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 )
	{
		$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '2' OR file_status = '3' OR file_status = '4')";
	}
	elseif( $user[ 'user_status' ] == 6 )
	{
		$file_status = "(file_status = '0' OR file_status = '1' OR file_status = '3' OR file_status = '4')";
	}
	else
	{
		$file_status = "(file_status = '0' OR file_status = '3')";
	}
	
	$query = $database -> dbquery( "SELECT file_id, file_author, file_category, file_name, file_version, file_seo, file_smalldescription, file_longdescription, file_description, file_keywords, file_size, file_cost, file_company, file_homepage, file_os, file_agreement, file_teaser, file_comments, file_allowcomments, file_status, file_password, file_date, file_fields, file_views, file_rating, file_votes FROM " . DB_PREFIX . "esselbach_ct_files WHERE file_seo = '" . $page_query . "' AND " . $file_status . " AND (file_website = '0' OR file_website = '" . intval( $config[ 'WEBSITE' ] ) . "')" );
	
	if( $database -> dbrows( $query ) )
	{
		list( $insert[ 'file_id' ], $insert[ 'file_author' ], $insert[ 'file_category' ], $insert[ 'file_name' ], $insert[ 'file_version' ], $insert[ 'file_seo' ], $insert[ 'file_smalldescription' ], $insert[ 'file_longdescription' ], $insert[ 'file_description' ], $insert[ 'file_keywords' ], $insert[ 'file_size' ], $insert[ 'file_cost' ], $insert[ 'file_company' ], $insert[ 'file_homepage' ], $insert[ 'file_os' ], $insert[ 'file_agreement' ], $insert[ 'file_teaser' ], $insert[ 'file_comments' ], $insert[ 'file_allowcomments' ], $insert[ 'file_status' ], $insert[ 'file_password' ], $insert[ 'file_date' ], $insert[ 'file_fields' ], $insert[ 'file_views' ], $insert[ 'file_rating' ], $insert[ 'file_votes' ] ) = $database -> dbrow( $query );
		
		if( $preferences[ 'files_allow_rating' ] and $insert[ 'file_votes' ] )
		{
			if( $insert[ 'file_rating' ] == 5 )
			{
				$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_5stars_html' ], $main_templates[ 'files_rating_5stars_php' ], $insert );
			}
			elseif( $insert[ 'file_rating' ] == 4 )
			{
				$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_4stars_html' ], $main_templates[ 'files_rating_4stars_php' ], $insert );
			}
			elseif( $insert[ 'file_rating' ] == 3 )
			{
				$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_3stars_html' ], $main_templates[ 'files_rating_3stars_php' ], $insert );
			}
			elseif( $insert[ 'file_rating' ] == 2 )
			{
				$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_2stars_html' ], $main_templates[ 'files_rating_2stars_php' ], $insert );
			}
			elseif( $insert[ 'file_rating' ] < 2 )
			{
				$insert[ 'file_rating_line' ] = $templates -> exectemplate( $main_templates[ 'files_rating_1star_html' ], $main_templates[ 'files_rating_1star_php' ], $insert );
			}
		}
		else
		{
			$insert[ 'file_rating_line' ] = "";
		}
		
		$insert[ 'param_ext' ] = $preferences[ 'param_ext' ];
		$insert[ 'param_ct' ] = $preferences[ 'param_ct' ];
		$insert[ 'param_action' ] = $preferences[ 'param_action' ];
		$insert[ 'param_page' ] = $preferences[ 'param_page' ];
		$insert[ 'param_id' ] = $preferences[ 'param_id' ];
		$insert[ 'file_name' ] = htmlspecialchars( $insert[ 'file_name' ] );
		$insert[ 'file_version' ] = htmlspecialchars( $insert[ 'file_version' ] );
		$insert[ 'file_author' ] = htmlspecialchars( $insert[ 'file_author' ] );
		$insert[ 'file_date' ] = $system -> convertdate( $insert[ 'file_date' ], $preferences[ 'files_dateformat' ], $preferences[ 'website_timezone' ] );
		
		if( $insert[ 'file_fields' ] )
		{
			$input_fields_array = explode( "|", $insert[ 'file_fields' ] );
			$extra = 0;
			
			for( $i = 0; $i < 24; $i++ )
			{
				$extra++;
				$insert[ 'file_extra' . $extra ] = $system -> decode( $input_fields_array[ $i ] );
			}
		}
		else
		{
			for( $i = 1; $i < 25; $i++ )
			{
				$insert[ 'file_extra' . $i ] = "";
			}
		}
		
		$query = $database -> dbquery( "SELECT filedownload_id, filedownload_file, filedownload_num, filedownload_name, filedownload_url, filedownload_downloads, filedownload_position FROM " . DB_PREFIX . "esselbach_ct_filesdownloads WHERE filedownload_file = '" . intval( $insert[ 'file_id' ] ) . "' AND filedownload_num = '" . $opt . "'" );
		list( $insert[ 'filedownload_id' ], $insert[ 'filedownload_file' ], $insert[ 'filedownload_num' ], $insert[ 'filedownload_name' ], $insert[ 'filedownload_url' ], $insert[ 'filedownload_downloads' ], $insert[ 'filedownload_position' ] ) = $database -> dbrow( $query );
		$insert[ 'page_name' ] = $insert[ 'file_name' ] . " " . $insert[ 'file_version' ];
		$insert[ 'page_description' ] = htmlspecialchars( $insert[ 'file_description' ] );
		$insert[ 'page_keywords' ] = htmlspecialchars( $insert[ 'file_keywords' ] );
		
		if( $insert[ 'file_status' ] == 3 )
		{
			$file_password = ( isset( $_POST[ 'file_password' ] ) ) ? $security -> checkvare( $_POST[ 'file_password' ] ) : "" ;
			$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;
			
			if( !$file_password )
			{
				session_start();
				$insert[ 'files_security_hash' ] = md5( rand( 1, 32768 ) );
				$_SESSION[ 'files_security_hash' ] = $insert[ 'files_security_hash' ];
				$file_notice = $templates -> exectemplate( $main_templates[ 'files_get_password_html' ], $main_templates[ 'files_get_password_php' ], $insert );
			}
			elseif( $file_password != $insert[ 'file_password' ] )
			{
				$file_notice = $templates -> exectemplate( $main_templates[ 'files_error_password_html' ], $main_templates[ 'files_error_password_php' ], $insert );
			}
			else
			{
				session_start();
				
				if( $_SESSION[ 'files_security_hash' ] != $input_security_hash )
				{
					echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
					echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
					echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
					exit;
				}
			}
		}
		
		if( $insert[ 'file_agreement' ] )
		{
			$file_agreed = ( isset( $_POST[ 'input_agree' ] ) ) ? $security -> checkvare( $_POST[ 'input_agree' ] ) : "" ;
			$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;
			
			if( !$file_agreed )
			{
				if( !isset( $insert[ 'files_security_hash' ] ) )
				{
					session_start();
					$insert[ 'files_security_hash' ] = md5( rand( 1, 32768 ) );
					$_SESSION[ 'files_security_hash' ] = $insert[ 'files_security_hash' ];
				}
				
				$file_notice = $templates -> exectemplate( $main_templates[ 'files_get_agreement_html' ], $main_templates[ 'files_get_agreement_php' ], $insert );
			}
			else
			{
				session_start();
				
				if( $_SESSION[ 'files_security_hash' ] != $input_security_hash )
				{
					echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
					echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
					echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
					exit;
				}
			}
		}
	}
	else
	{
		$file_notice = $templates -> exectemplate( $main_templates[ 'files_error_nofile_html' ], $main_templates[ 'files_error_nofile_php' ], $insert );
	}
	
	$blocks = $templates -> prepareblocks( $main_templates[ 'site_block_html' ], $main_templates[ 'site_block_php' ], $insert );
	
	foreach( $blocks as $block_id => $block_content )
	{
		$insert[ 'site_block_' . $block_id ] = $block_content;
	}
	
	echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
	
	if( !isset( $insert[ 'filedownload_url' ] ) or( isset( $file_notice ) ) )
	{
		$insert[ 'page_name' ] = htmlspecialchars( $preferences[ 'website_name' ] );
		$insert[ 'page_description' ] = htmlspecialchars( $preferences[ 'website_description' ] );
		$insert[ 'page_keywords' ] = htmlspecialchars( $preferences[ 'website_keywords' ] );
		
		if( $preferences[ 'files_navigation' ] )
		{
			echo $templates -> exectemplate( $main_templates[ 'files_header_html' ], $main_templates[ 'files_header_php' ], $insert );
		}
		
		echo $file_notice;
		
		if( $preferences[ 'files_navigation' ] )
		{
			echo $templates -> exectemplate( $main_templates[ 'files_footer_html' ], $main_templates[ 'files_footer_php' ], $insert );
		}
	}
	else
	{
		if( $preferences[ 'files_navigation' ] )
		{
			$insert[ 'files_header' ] = $templates -> exectemplate( $main_templates[ 'files_get_header_html' ], $main_templates[ 'files_get_header_php' ], $insert );
		}
		
		session_start();
		$_SESSION[ 'filedownload_url' ] = base64_encode( $insert[ 'filedownload_url' ] );
		
		if( defined( "SID" ) )
		{
			$insert[ 'file_session_redirect' ] = "&" . htmlentities( SID );
			$insert[ 'file_session_link' ] = "&amp;" . htmlentities( SID );
		}
		else
		{
			$insert[ 'file_session_redirect' ] = "";
			$insert[ 'file_session_link' ] = "";
		}
		
		$insert[ 'files_get' ] = $templates -> exectemplate( $main_templates[ 'files_get_html' ], $main_templates[ 'files_get_php' ], $insert );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_files SET file_downloads = file_downloads + 1 WHERE file_id = '" . intval( $insert[ 'file_id' ] ) . "'" );
		$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_filesdownloads SET filedownload_downloads = filedownload_downloads +1, filedownload_activity = now() WHERE filedownload_file = '" . intval( $insert[ 'file_id' ] ) . "' AND filedownload_num = '" . $opt . "'" );
		
		if( $preferences[ 'files_navigation' ] )
		{
			$insert[ 'files_footer' ] = $templates -> exectemplate( $main_templates[ 'files_get_footer_html' ], $main_templates[ 'files_get_footer_php' ], $insert );
		}
		
		echo $templates -> exectemplate( $main_templates[ 'files_layout_get_html' ], $main_templates[ 'files_layout_get_php' ], $insert );
	}
	
	echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
}
?>